local waterfall = AceLibrary and AceLibrary:HasInstance("Waterfall-1.0") and AceLibrary("Waterfall-1.0")

local dataobj = LibStub('LibDataBroker-1.1'):NewDataObject('Broker_Grid', {
	type = 'luncher',
	icon = [[Interface\AddOns\Broker_Grid\icon]],
	label = 'Broker_Grid'
})
local Dewdrop

local function buildmenu(self)
	if not Dewdrop then
		Dewdrop = AceLibrary("Dewdrop-2.0")
	end
	if not Dewdrop then return end
	if not Dewdrop:IsRegistered(self:GetFrame()) then
		if type(self.OnMenuRequest) == "table" and (not self.OnMenuRequest.handler or self.OnMenuRequest.handler == self) and self.OnMenuRequest.type == "group" then
			Dewdrop:InjectAceOptionsTable(self, self.OnMenuRequest)
		end
		Dewdrop:Register(self:GetFrame(),
			'children', type(self.OnMenuRequest) == "table" and self.OnMenuRequest or function(level, value, valueN_1, valueN_2, valueN_3, valueN_4)
				if level == 1 then
					Dewdrop:AddLine(
						'text', CLOSE,
						'tooltipTitle', CLOSE,
						'tooltipText', CLOSE_DESC,
						'func', Dewdrop.Close,
						'arg1', Dewdrop
					)
				end
				if self.OnMenuRequest then
					self:OnMenuRequest(level, value, false, valueN_1, valueN_2, valueN_3, valueN_4)
				end
			end,
			'point', function(frame)
				local x, y = frame:GetCenter()
				local leftRight
				if x < GetScreenWidth() / 2 then
					leftRight = "LEFT"
				else
					leftRight = "RIGHT"
				end
				if y < GetScreenHeight() / 2 then
					return "BOTTOM" .. leftRight, "TOP" .. leftRight
				else
					return "TOP" .. leftRight, "BOTTOM" .. leftRight
				end
			end,
			'dontHook', true
		)
	end
end

function dataobj.OnClick(self,button)
	if Grid2 then
		InterfaceOptionsFrame_OpenToCategory'Grid2'
	elseif Grid then
		if not Dewdrop then
			buildmenu(FuBarPluginGridFrame.self)
		end
		if button == 'RightButton' and Dewdrop then
			if not Dewdrop:IsOpen(self) then
				Dewdrop:Open(self, FuBarPluginGridFrame)
			else
				Dewdrop:Close()
			end
		elseif waterfall then
			if waterfall:IsOpen("Grid") then
				waterfall:Close("Grid")
			else
				waterfall:Open("Grid")
			end
		end
	end
end


